import 'package:flutter/cupertino.dart';

import 'page/cupertino_pages.dart';
import 'page/cupertino_slider.dart';
import 'page/page.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return CupertinoApp(
      title: 'FormCupertinoFields',
      home: HomePage(),
    );
  }
}

class HomePage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return CupertinoPageScaffold(
      child: ListView(
        children: [
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoTextFieldPage()));
              },
              child: Text('FormeCupertinoTextField')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoSliderPage()));
              },
              child: Text('FormeCupertinoSlider')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoPickerFieldPage()));
              },
              child: Text('FormeCupertinoPicker')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoTimerFieldPage()));
              },
              child: Text('FormeCupertinoTimerField')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoDateFieldPage()));
              },
              child: Text('FormeCupertinoDateField')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoSegmentedControlPage()));
              },
              child: Text('FormeCupertinoSegmentedControl')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) =>
                            CupertinoSlidingSegmentedControlPage()));
              },
              child: Text('FormeCupertinoSlidingSegmentedControl')),
          CupertinoButton(
              onPressed: () {
                Navigator.push(
                    context,
                    CupertinoPageRoute(
                        builder: (context) => CupertinoDemoPage()));
              },
              child: Text('FormeCupertinoDemoPage')),
        ],
      ),
    );
  }
}
