import 'package:flutter/cupertino.dart';
import 'package:forme/forme.dart';

import 'package:forme_cupertino_fields/forme_cupertino_fields.dart';
import 'base_page.dart';

class CupertinoDateFieldPage
    extends BasePage<DateTime, FormeCupertinoDateFieldModel> {
  @override
  Widget get body {
    return Column(
      children: [
        CupertinoFormSection.insetGrouped(
          header: const Text('SECTION 1'),
          children: [
            FormeCupertinoDateField(
              name: name,
              decoratorBuilder:
                  FormeCupertinoInputDecoratorBuilder(prefix: Text('datetime')),
              listener: FormeValueFieldListener(
                autovalidateMode: AutovalidateMode.onUserInteraction,
                onValidate: FormeValidates.notNull(errorText: 'select a date!'),
              ),
              model: FormeCupertinoDateFieldModel(
                  textFieldModel: FormeCupertinoTextFieldModel(
                placeholder: 'Enter text',
              )),
            ),
          ],
        ),
        Wrap(
          children: [
            createButton('set type to datetime', () async {
              controller.updateModel(FormeCupertinoDateFieldModel(
                type: FormeDateTimeFieldType.DateTime,
              ));
            }),
            createButton('set type to date', () async {
              controller.updateModel(FormeCupertinoDateFieldModel(
                type: FormeDateTimeFieldType.Date,
              ));
            }),
            createButton('set maximumDate to prev day', () async {
              controller.updateModel(FormeCupertinoDateFieldModel(
                maximumDate: DateTime.now().add(Duration(days: -1)),
              ));
            }),
            createButton('set minuteInterval to 5', () async {
              controller.updateModel(FormeCupertinoDateFieldModel(
                minuteInterval: 5,
              ));
            }),
            createButton('validate', () {
              controller.validate();
            }),
          ],
        )
      ],
    );
  }

  @override
  String get title => 'FormeCupertinoTimerField';
}
