import 'package:flutter/cupertino.dart';
import 'package:forme/forme.dart';

import 'package:forme_cupertino_fields/forme_cupertino_fields.dart';
import 'base_page.dart';
import 'cupertino_segmented_control.dart';

class CupertinoSlidingSegmentedControlPage extends BasePage<String?,
    FormeCupertinoSlidingSegmentedControlModel<String>> {
  @override
  Widget get body {
    return Column(
      children: [
        FormeCupertinoSlidingSegmentedControl<String>(
          model: FormeCupertinoSlidingSegmentedControlModel<String>(),
          listener: FormeValueFieldListener(
            onValidate: FormeValidates.equals('C', errorText: 'pls select C'),
            autovalidateMode: AutovalidateMode.onUserInteraction,
            onValueChanged: (c, v) =>
                print('value changed,current value is $v'),
          ),
          name: name,
          chidren: {
            'A': ReadOnlyWidget(
              text: 'A',
              formeKey: formKey,
              name: name,
            ),
            'B': ReadOnlyWidget(
              text: 'B',
              formeKey: formKey,
              name: name,
            ),
            'C': FormeValueFieldBuilder(
              builder: (context, controller) {
                return ValueListenableBuilder2<bool, FormeValidateError?>(
                  controller.readOnlyListenable,
                  controller.errorTextListenable,
                  child: Text('C'),
                  builder: (context, r, v, child) {
                    if (r)
                      return Text(
                        'C',
                        style: TextStyle(color: CupertinoColors.systemGrey),
                      );
                    if (v == null || !v.invalid) return child!;
                    return ShakeWidget(
                      child: child!,
                      key: UniqueKey(),
                    );
                  },
                );
              },
            ),
          },
        ),
        Wrap(
          children: [
            createButton('update children', () async {
              controller.updateModel(
                  FormeCupertinoSlidingSegmentedControlModel<String>(
                children: List.generate(
                    5,
                    (index) => Text(
                          index.toString(),
                          style: TextStyle(color: CupertinoColors.systemGreen),
                        )).asMap().map(
                    (key, value) => MapEntry(key.toString(), value)),
              ));
            }),
            Builder(builder: (context) {
              return ValueListenableBuilder<bool>(
                  valueListenable: formKey.valueField(name).readOnlyListenable,
                  builder: (context, v, child) {
                    return createButton(v ? 'editable' : 'readOnly', () {
                      controller.readOnly = !v;
                    });
                  });
            }),
            createButton('update labelText', () async {
              updateLabel();
            }),
            createButton('set helper text', () {
              updateHelper();
            }),
            createButton('validate', () {
              controller.validate();
            }),
          ],
        )
      ],
    );
  }

  @override
  String get title => 'FormeCupertinoSlidingSegmentedControl';
}
