import 'package:flutter/cupertino.dart';
import 'package:forme/forme.dart';

import 'package:forme_cupertino_fields/forme_cupertino_fields.dart';
import 'base_page.dart';

class CupertinoTimerFieldPage
    extends BasePage<Duration, FormeCupertinoTimerFieldModel> {
  @override
  Widget get body {
    return Column(
      children: [
        CupertinoFormSection.insetGrouped(
          header: const Text('SECTION 1'),
          children: [
            FormeCupertinoTimerField(
              listener: FormeValueFieldListener(
                autovalidateMode: AutovalidateMode.onUserInteraction,
                onValidate:
                    FormeValidates.notNull(errorText: 'select a duration!'),
              ),
              name: name,
              decoratorBuilder:
                  FormeCupertinoInputDecoratorBuilder(prefix: Text('duration')),
              model: FormeCupertinoTimerFieldModel(
                  textFieldModel: FormeCupertinoTextFieldModel(
                placeholder: 'Enter text',
              )),
            ),
          ],
        ),
        Wrap(
          children: [
            createButton('change mode to ms', () async {
              controller.updateModel(FormeCupertinoTimerFieldModel(
                mode: CupertinoTimerPickerMode.ms,
              ));
            }),
            createButton('update', () async {
              controller.updateModel(FormeCupertinoTimerFieldModel(
                minuteInterval: 10,
                secondInterval: 10,
                backgroundColor: CupertinoColors.systemPurple.withOpacity(0.3),
              ));
            }),
            createButton('validate', () {
              controller.validate();
            }),
          ],
        ),
      ],
    );
  }

  @override
  String get title => 'FormeCupertinoTimerField';
}
